/* Wed Mar 17 18:57:03 1993 GER:
   aus gnulib2.c diverser Kleinkram:
   hier:
   __main() etc.
*/

#define HAVE_ATEXIT

#include "types.h"
#include <stddef.h>

#include "gbl-ctors.h"

/* Run all the global destructors on exit from the program.  */

void
__do_global_dtors ()
{
  int nptrs = *(int *)__DTOR_LIST__;

  /* There are two formats for the table __DTOR_LIST__:
     GNU ld: first word is number of pointers, followed by that many pointers.
     ELF/COFF: first word is -1, followed by pointers up to __DTOR_END__.  */

  if (nptrs != -1)
    {
      /* GNU LD format.  */
      int i;
      for (i = nptrs; i >= 1; i--)
/* orig:   for (i = nptrs - 1; i >= 1; i--) */
	__DTOR_LIST__[i] ();
    }
  else
    {
      /* COFF, ELF format.  */
      func_ptr *p;
      for (p = __DTOR_END__; p > __DTOR_LIST__ + 1; )
	(*--p) ();
    }
}

#ifndef INIT_SECTION_ASM_OP
/* Run all the global constructors on entry to the program.  */

#define HAVE_ATEXIT

void
__do_global_ctors ()
{
  DO_GLOBAL_CTORS_BODY;
}
#endif /* defined(INIT_SECTION_ASM_OP) */

/* Subroutine called automatically by `main'.
   Compiling a global function named `main'
   produces an automatic call to this function at the beginning.

   For many systems, this routine calls __do_global_ctors.
   For systems which support a .init section we use the .init section
   to run __do_global_ctors, so we need not do anything here.  */

void
__main ()
{
#ifndef INIT_SECTION_ASM_OP
  /* Support recursive calls to `main': run initializers just once.  */
  static initialized = 0;
  if (! initialized)
    {
      initialized = 1;
      __do_global_ctors ();
    }
#endif /* not INIT_SECTION_ASM_OP */
}


/* Provide default definitions for the lists of constructors and
   destructors, so that we don't get linker errors.  These symbols are
   intentionally bss symbols, so that gld and/or collect will provide
   the right values.  */

#ifndef INIT_SECTION_ASM_OP
func_ptr __CTOR_LIST__[1];
func_ptr __CTOR_END__[1];
func_ptr __DTOR_LIST__[1];
func_ptr __DTOR_END__[1];
#endif /* INIT_SECTION_ASM_OP */

#ifndef ON_EXIT

/* If we have no known way of registering our own __do_global_dtors
   routine so that it will be invoked at program exit time, then we
   have to define our own exit routine which will get this to happen.  */

extern void __do_global_dtors ();
extern void _cleanup ();
extern void _exit ();

/* void
exit (status)
     int status;
{
  __do_global_dtors ();
#ifdef EXIT_BODY
  EXIT_BODY;
#else
  _cleanup ();
#endif
  _exit (status);
} */

#else
int _exit_dummy_decl = 0;	/* prevent compiler & linker warnings */
#endif

